﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace UtiliKey
{
    struct Command
    {
        #region Fields
        private string name;
        private CommandAction action;

        private bool _oneWay;
        private bool _unicodeAllowed;

        public bool OneWay { get { return _oneWay; } }
        public bool UnicodeAllowed { get { return _unicodeAllowed; } }
        #endregion

        #region Constructors
        public Command(string Name, CommandAction Action)
            : this(Name, Action, false, true)
        {
        }

        public Command(string Name, CommandAction Action, bool OneWay)
            : this(Name, Action, OneWay, false)
        {
        }

        public Command(string Name, CommandAction Action, bool OneWay,
            bool UnicodeAllowed)
        {
            name = Name;
            action = Action;
            _oneWay = OneWay;
            _unicodeAllowed = UnicodeAllowed;
        }
        #endregion

        #region Methods
        public string Action(string Text, bool Modify)
        {
            return action.Invoke(Text, Modify);
        }

        public override string ToString()
        {
            return name;
        }
        #endregion
    }

    delegate string CommandAction(string str, bool decode);
}
