﻿using System;
using System.Text;
using System.Web;

namespace UtiliKey
{
    class HtmlTransforms
    {
        #region URL Encoding
        private static string UrlCode(string str, bool decode, UrlType type)
        {
            /*
            Do not specify encoding with HttpUtility.UrlDecode()! Otherwise,
            it returns mojibake if it's set to Unicode, and 
            unicode-characters are ??? if it's set to Ascii.
             */
            if (decode) return HttpUtility.UrlDecode(str);
            switch (type)
            {
                case UrlType.ALLCHARS:
                    char[] allChars = str.ToCharArray();
                    string endString = "";
                    for (int i = 0; i < allChars.Length; i++)
                    {
                        int curChar = (int)allChars[i];
                        if (curChar < 127) endString += "%" +
                             Convert.ToString(curChar, 16).PadLeft(2, '0');
                        else endString +=
                            HttpUtility.UrlPathEncode(allChars[i].ToString());
                    }

                    return endString;
                case UrlType.SAFE:
                    str = HttpUtility.UrlPathEncode(str);
                    return str.Replace(" ", "%20");
                default:
                    str = HttpUtility.UrlEncode(str);
                    str = str.Replace("(", "%28");
                    str = str.Replace(")", "%29");
                    return str.Replace("+", "%20");
            }
        }

        public static string UrlNormal(string str, bool decode)
        {
            return UrlCode(str, decode, UrlType.NORMAL);
        }

        public static string UrlSafe(string str, bool decode)
        {
            return UrlCode(str, decode, UrlType.SAFE);
        }

        public static string UrlAllChars(string str, bool decode)
        {
            return UrlCode(str, decode, UrlType.ALLCHARS);
        }

        private enum UrlType
        {
            NORMAL,
            SAFE,
            ALLCHARS
        }
        #endregion

        #region HTML Entities
        public static string HTMLEntities(string str, bool decode)
        {
            if (decode) return HttpUtility.HtmlDecode(str);
            str = HttpUtility.HtmlEncode(str);

            string retStr = "";

            char[] strArray = str.ToCharArray();

            for (int i = 0; i < str.Length; i++)
            {
                if ((int)strArray[i] > 127)
                    retStr += "&#x" + Convert.ToString(strArray[i], 16) + ";";
                else retStr += strArray[i];
            }

            return retStr;
        }
        #endregion
    }
}
