﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace UtiliKey
{
    static class WidthTransforms
    {
        #region Constants
        private const string FullWidthChars =
            ("！＂＃＄％＆＇（）＊＋，－．／０１２３４５６７８９：；＜＝＞？＠ＡＢＣＤＥＦＧＨＩＪＫＬＭＮＯＰＱＲＳＴＵＶＷＸＹＺ［＼］＾＿｀ａｂｃｄｅｆｇｈｉｊｋｌｍｎｏｐｑｒｓｔｕｖｗｘｙｚ｛｜｝～｟｠" +
            "。「」、・ヲァィゥェォャュョッーアイウエオカキクケコサシスセソタチツテトナニヌネノハヒフヘホマミムメモヤユヨラリルレロワン゙゚" +
            "ㅤㄱㄲㄳㄴㄵㄶㄷㄸㄹㄺㄻㄼㄽㄾㄿㅀㅁㅂㅃㅄㅅㅆㅇㅈㅉㅊㅋㅌㅍㅎㅏㅐㅑㅒㅓㅔㅕㅖㅗㅘㅙㅚㅛㅜㅝㅞㅟㅠㅡㅢㅣ" +
            "￠￡￢￣￤￥￦│←↑→↓■○");

        private const string HalfWidthChars =
            ("!\"#$%&'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~⦅⦆" +
            "｡｢｣､･ｦｧｨｩｪｫｬｭｮｯｰｱｲｳｴｵｶｷｸｹｺｻｼｽｾｿﾀﾁﾂﾃﾄﾅﾆﾇﾈﾉﾊﾋﾌﾍﾎﾏﾐﾑﾒﾓﾔﾕﾖﾗﾘﾙﾚﾛﾜﾝﾞﾟ" +
            "ﾠﾡﾢﾣﾤﾥﾦﾧﾨﾩﾪﾫﾬﾭﾮﾯﾰﾱﾲﾳﾴﾵﾶﾷﾸﾹﾺﾻﾼﾽﾾￂￃￄￅￆￇￊￋￌￍￎￏￒￓￔￕￖￗￚￛￜ" +
            "¢£¬¯¦¥₩￨￩￪￫￬￭￮");
        #endregion

        public static string ToFullWidth(string startString)
        {
            StringBuilder returnString = new StringBuilder();

            foreach (char curChar in startString)
            {
                int dex = HalfWidthChars.IndexOf(curChar);

                if (dex < 0) returnString.Append(curChar);
                else returnString.Append(FullWidthChars[dex]);
            }

            return returnString.ToString();
        }

        public static string ToHalfWidth(string startString)
        {
            StringBuilder returnString = new StringBuilder();

            foreach (char curChar in startString)
            {
                int dex = FullWidthChars.IndexOf(curChar);

                if (dex < 0) returnString.Append(curChar);
                else returnString.Append(HalfWidthChars[dex]);
            }

            return returnString.ToString();
        }

        internal static string Convert(string str, bool decode)
        {
            if (decode) return ToHalfWidth(str);
            return ToFullWidth(str);
        }
    }
}
